/*
 * gpx
 *
 * (C) 1989 Saeko Hirabauashi & Kouichi Hirabayashi
 *
 * Absolutely no warranty. Use this software with your own risk.
 *
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright and disclaimer notice.
 */


#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <string.h>
#include "gpx.h"
/*#include "../e5810/gpib.h"*/

extern char **FS, **FILENAME;
extern char record[];
extern FILE *ifp;
extern gpfd;

NODE *parse();
CELL *execute();
FILE *efopen();
char *strsave();

char *gateway;
int xargc;
char **xargv;
char *srcprg;
FILE *pfp;
char *cmd;

main(argc, argv) char **argv;
{
  char *s;
  void onint();

  cmd = argv[0];
  while (--argc > 0 && (*++argv)[0] == '-')
	for (s = argv[0]+1; *s; s++)
		if (strcmp(argv[0], "-") == 0)
			break;
		else
		switch (*s) {
		case 'F':
			*FS = ++s;
			break;
		case 'f':
			if (*(s+1))
				s++;
			else {
				argc--; s = *++argv;
			}
			pfp = efopen(s, "r");
			s += strlen(s) - 1;
			break;
		case 'g':
			if (*(s+1))
				s++;
			else {
				argc--; s = *++argv;
			}
			gateway = argv[0];
			s += strlen(s) - 1;
			break;
		}
  xargc = argc; xargv = argv;
  gbint(&onint);
  init();
  if (pfp == NULL && xargc > 0) {
	srcprg = *xargv++; xargc--;
  }
  while (*xargv != NULL && strchr(*xargv, '=') != NULL) {
	setvar(*xargv++);
	xargc--;
  }

  initarg(cmd, xargc, xargv);
  if (argc == 0) {
	pfp = stdin; *FILENAME = "-";
  }
  parse();
  closeall();
  if (gpfd)
	gbcls();
  exit(0);
}

FILE *
efopen(file, mode) char *file, *mode;
{
  FILE *fp, *fopen();

  if ((fp = fopen(file, mode)) == NULL)
	error("cannot open %s", file);
  return fp;
}

error(s, t) char *s, *t;
{
  extern double *NR;

  fprintf(stderr, "gpx: ");
  fprintf(stderr, s, t);
  fprintf(stderr, "\n");
  fprintf(stderr, "record number %g\n", *NR);
  if (gpfd)
	gbcls();
  closeall();
  exit(1);
}

void
onint(i)
{
  closeall();
  rawmode(-1);
  fprintf(stderr, "%s: Ǥޤ\n", cmd);
  exit(0);
}
